From 1a3db3cf129d76fb911964dc22f4d924f182dfa9 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: May 21 2015 17:31:59 +0000
Subject: [PATCH 19/254] Give every widget a link to its own source code.


---

diff --git a/hubs/app.py b/hubs/app.py
index d6f5510..4e1e666 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -65,14 +65,12 @@ def widget(hub, idx):
     return widget.render(session, hub, idx)
 
 
-@app.route('/<hub>/<idx>/source')
-@app.route('/<hub>/<idx>/source/')
-def widget_source(hub, idx):
+@app.route('/source/<name>')
+@app.route('/source/<name>/')
+def widget_source(name):
     from hubs.widgets import registry
     base = '/hubs/'
-    session = models.init(app.config['DB_URL'])
-    widget = get_widget(session, hub, idx)
-    fname = base + registry[widget.plugin].__file__.split(base, 1)[1][:-1]
+    fname = base + registry[name].__file__.split(base, 1)[1][:-1]
     return flask.redirect(SOURCE_URL + fname)
 
 
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 1c83230..30fc102 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -3,6 +3,10 @@ import stats
 import rules
 import sticky
 
+from base import AGPLv3
+
+import flask
+
 registry = {
     'dummy': dummy,
     'stats': stats,
@@ -32,6 +36,9 @@ def prepare_registry(registry):
         if hasattr(module, 'chrome'):
             module.render = module.chrome(module.render)
 
+        # Put source links in all API results
+        module.data = AGPLv3(name)(module.data)
+
         # TODO -- wrap a cache layer around the data functions
         #         do this only if the module provides a cache invalidator
         #         and warn in the logs if there's not one present?
diff --git a/hubs/widgets/base.py b/hubs/widgets/base.py
index 04e1fc5..de78e5e 100644
--- a/hubs/widgets/base.py
+++ b/hubs/widgets/base.py
@@ -3,6 +3,8 @@ import functools
 import hashlib
 import urllib
 
+import flask
+
 Argument = collections.namedtuple(
     'Argument', ('name', 'default', 'validator', 'help'))
 
@@ -17,6 +19,19 @@ def argument(name, default, validator, help):
         return inner
     return decorator
 
+
+def AGPLv3(name):
+    def decorator(func):
+        @wraps(func)
+        def inner(*args, **kwargs):
+            result = func(*args, **kwargs)
+            result['source_url'] = flask.url_for('widget_source', name=name)
+            return result
+
+        return inner
+    return decorator
+
+
 def wraps(original):
     @functools.wraps(original)
     def decorator(subsequent):
diff --git a/hubs/widgets/chrome.py b/hubs/widgets/chrome.py
index 1f8d399..07c4745 100644
--- a/hubs/widgets/chrome.py
+++ b/hubs/widgets/chrome.py
@@ -1,21 +1,28 @@
 from base import wraps
 
-_panel_template = """
-<div class="panel {klass}">
-  {heading}
+import jinja2
+
+_panel_template = jinja2.Template("""
+<div class="panel {{klass}}">
+  {{heading}}
+  <div class="pull-right widget-buttons">
+    <!-- the AGPLv3 wrapper puts the source url in all responses -->
+    <a href="{{source_url}}"><span class="glyphicon glyphicon-eye-open"></span></a>
+    <a href="#"><span class="glyphicon glyphicon-edit"></span></a>
+  </div>
   <div class="panel-body">
-    {content}
+    {{content}}
   </div> <!-- end panel-body -->
 </div> <!-- end panel -->
-"""
+""")
 
-_panel_heading_template = """
+_panel_heading_template = jinja2.Template("""
   <div class="panel-heading">
     <h3 class="panel-title">
-      {title}
+      {{title}}
     </h3>
   </div> <!-- end panel-heading -->
-"""
+""")
 
 
 def panel(title=None, klass="panel-default"):
@@ -24,8 +31,12 @@ def panel(title=None, klass="panel-default"):
         def inner(*args, **kwargs):
             heading = ''
             if title:
-                heading = _panel_heading_template.format(title=title)
+                heading = _panel_heading_template.render(title=title)
             content = func(*args, **kwargs)
-            return _panel_template.format(content=content, heading=heading, klass=klass)
+            return _panel_template.render(
+                content=content,
+                heading=heading,
+                klass=klass,
+                **kwargs)
         return inner
     return decorator

